JavaScript Grid: Get Started with AG Grid
AG Grid is the industry standard for JavaScript Enterprise Applications. Developers using AG Grid are building applications that would not be possible if AG Grid did not exist.
const columnDefs = [
{ field: "make" },
{ field: "model" },
{ field: "price" }
];
// specify the data
const rowData = [
{ make: "Toyota", model: "Celica", price: 35000 },
{ make: "Ford", model: "Mondeo", price: 32000 },
{ make: "Porsche", model: "Boxter", price: 72000 }
];
// let the grid know which columns and what data to use
const gridOptions = {
columnDefs: columnDefs,
rowData: rowData
};
// setup the grid after the page has finished loading
document.addEventListener('DOMContentLoaded', () => {
const gridDiv = document.querySelector('#myGrid');
new agGrid.Grid(gridDiv, gridOptions);
});
<!DOCTYPE html>
<html lang="en">
<head>
<title>Ag-Grid Basic Example</title>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.js"></script>
<script src="main.js"></script>
</head>
<body>
<div id="myGrid" style="height: 200px; width:500px;" class="ag-theme-alpine"></div>
</body>
</html>
Getting Started
In this article, we will walk you through the necessary steps to add AG Grid to an existing JavaScript project, and configure some of the essential features of it. We will show you some of the fundamentals of the grid (passing properties, using the API, etc).
The Project Setup
During the last couple of years, we are witnessing a Cambrian Explosion of JavaScript project stacks. It seems like everyday there is a new, better way for JavaScript developers to build and distribute their apps. However, for the purposes of this setup, we are going to stick to tried-and-true no-build, single HTML file setup which loads the AG Grid scripts from CDN (our favorite one is unpkg). Let's start from this clean html file:
<!DOCTYPE html>
<html>
<head>
</head>
<body>
<h1>Hello from ag-grid!</h1>
</body>
</html>
You can either use your favorite programming text editor, or you can execute the steps in the tutorial using this Plunker as a starting point.
Add AG Grid to Your Project
We are going to load the necessary scripts and styles from the unpkg CDN. Add the following to the head
element:
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-alpine.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
</body>
</html>
The lines above import the AgGrid
component, the grid "structure" stylesheet (ag-grid.css
), and one
of the available grid themes: (ag-theme-alpine.css
). The grid ships several different themes; pick one
that matches your project design.
Now, let's instantiate a grid!
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-alpine.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
<div id="myGrid" class="ag-theme-alpine" style="height: 600px; width:500px;"></div>
<script type="text/javascript" charset="utf-8">
// specify the columns
const columnDefs = [
{ field: "make" },
{ field: "model" },
{ field: "price" }
];
// specify the data
const rowData = [
{ make: "Toyota", model: "Celica", price: 35000 },
{ make: "Ford", model: "Mondeo", price: 32000 },
{ make: "Porsche", model: "Boxter", price: 72000 }
];
// let the grid know which columns and what data to use
const gridOptions = {
columnDefs: columnDefs,
rowData: rowData
};
// lookup the container we want the Grid to use
const eGridDiv = document.querySelector('#myGrid');
// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(eGridDiv, gridOptions);
</script>
</body>
</html>
The variables above present two essential configuration properties of the grid -
the column definitions
(columnDefs
) and the data (rowData
). In our case, the column definitions contain three columns; each
column entry specifies the header label and the data field to be displayed in the body of the table.
The actual data is defined in the rowData
as an array of objects. Notice that the fields of the objects
match the field
values in the columnDefs
configuration object.
Finally, the DIV
element is the DOM entry point of the grid. It sets the grid dimensions and specifies the
grid's theme by setting the class
to ag-theme-alpine
. As you may have already noticed, the CSS class
matches the name of CSS file we imported earlier.

Enable Sorting And Filtering
So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the least/most
expensive Well, enabling sorting in AG Grid is actually quite simple - all you need to do is add sortable
to
each column.
const columnDefs = [
{ field: "make", sortable: true },
{ field: "model", sortable: true },
{ field: "price", sortable: true }
];
After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.
Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) of rows, with many columns. In a data set like this filtering is your friend.
As with sorting, enabling filtering is as easy as adding the filter
property:
const columnDefs = [
{ field: "make", sortable: true, filter: true },
{ field: "model", sortable: true, filter: true },
{ field: "price", sortable: true, filter: true }
];
With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with a filtering UI which lets you choose the kind of filter and the text that you want to filter by.

Fetch Remote Data
Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most of the
time, we are dealing with data that resides on a remote server. Nowadays, implementing this is actually
quite simple. Notice that the actual data fetching is performed outside of the grid component - We are
using the HTML5 fetch
API.
If you have to support older browsers but you want to use fetch, you can add the respective polyfill.
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-alpine.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
<div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-alpine"></div>
<script type="text/javascript" charset="utf-8">
// specify the columns
const columnDefs = [
{ field: "make" },
{ field: "model" },
{ field: "price" }
];
// let the grid know which columns to use
const gridOptions = {
columnDefs: columnDefs
};
// lookup the container we want the Grid to use
const eGridDiv = document.querySelector('#myGrid');
// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(eGridDiv, gridOptions);
agGrid.simpleHttpRequest({url: 'https://www.ag-grid.com/example-assets/row-data.json'}).then(data => {
gridOptions.api.setRowData(data);
});
</script>
</body>
</html>
Here, we replaced the rowData
assignment with a data fetch from a remote service. The remote data is the
same as the one we initially had, so you should not notice any actual changes to the grid.
Notice that we also did something new - we accessed the grid API instance through the
gridOptions.api
. The api object exposes plethora of methods that allow us to implement complex scenarios
with the grid.
Enable Selection
Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.
Fortunately, the above task is quite simple with AG Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties:
// specify the columns
const columnDefs = [
{ field: "make", checkboxSelection: true },
{ field: "model" },
{ field: "price" }
];
// let the grid know which columns and what data to use
const gridOptions = {
columnDefs: columnDefs,
rowSelection: 'multiple'
};
Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we need the following change:
<button onclick="getSelectedRows()">Get Selected Rows</button>
<div id="myGrid" class="ag-theme-alpine" style="height: 600px; width:500px;"></div>
const getSelectedRows = () => {
const selectedNodes = gridOptions.api.getSelectedNodes()
const selectedData = selectedNodes.map( node => node.data )
const selectedDataStringPresentation = selectedData.map( node => `${node.make} ${node.model}`).join(', ')
alert(`Selected nodes: ${selectedDataStringPresentation}`);
}
Well, we cheated a bit. Calling alert
is not exactly a call to our backend. Hopefully you will forgive us
this shortcut for the sake of keeping the article short and simple. Of course, you can substitute that bit
with a real-world application logic after you are done with the tutorial.
What happened above? Several things:
- We added a button with an event handler;
- Inside the event handler, we accessed the grid API to get the currently selected grid row nodes;
- Afterwards, we extracted the row nodes' underlying data items and converted them to a string suitable to be presented to the user in an alert box.
Grouping
Grouping is a feature exclusive to AG Grid Enterprise. You are free to trial AG Grid Enterprise to see what you think. You only need to get in touch if you want to start using AG Grid Enterprise in a project intended for production.
In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data.
Let's enable the enterprise features of ag-grid. Install the additional package:
Now, let's use ag-grid-enterprise! Replace the ag-grid script reference in the head
with this one:
<script src="https://unpkg.com/ag-grid-enterprise/dist/ag-grid-enterprise.min.noStyle.js"></script>
If everything is ok, you should see a message in the console that tells you there is no enterprise license key. You can ignore the message as we are trialing. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

Now, let's enable grouping! Change the configuration to this:
const columnDefs = [
{ field: "make", rowGroup: true },
{ field: "price" }
];
const autoGroupColumnDef = {
headerName: "Model",
field: "model",
cellRenderer:'agGroupCellRenderer',
cellRendererParams: {
checkbox: true
}
}
// let the grid know which columns and what data to use
const gridOptions = {
columnDefs: columnDefs,
autoGroupColumnDef: autoGroupColumnDef,
groupSelectsChildren: true,
rowSelection: 'multiple'
};
There we go! The grid now groups the data by make
, while listing the model
field value when expanded.
Notice that grouping works with checkboxes as well - the groupSelectsChildren
property adds a group-level
checkbox that selects/deselects all items in the group.
Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.
This is how the final code should look:
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-enterprise/dist/ag-grid-enterprise.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-alpine.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
<button onclick="getSelectedRows()">Get Selected Rows</button>
<div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-alpine"></div>
<script type="text/javascript" charset="utf-8">
// specify the columns
const columnDefs = [
{ field: "make", rowGroup: true },
{ field: "price" }
];
const autoGroupColumnDef = {
headerName: "Model",
field: "model",
cellRenderer:'agGroupCellRenderer',
cellRendererParams: {
checkbox: true
}
}
// let the grid know which columns and what data to use
const gridOptions = {
columnDefs: columnDefs,
autoGroupColumnDef: autoGroupColumnDef,
groupSelectsChildren: true,
rowSelection: 'multiple'
};
// lookup the container we want the Grid to use
const eGridDiv = document.querySelector('#myGrid');
// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(eGridDiv, gridOptions);
agGrid.simpleHttpRequest({url: 'https://www.ag-grid.com/example-assets/row-data.json'}).then(data => {
gridOptions.api.setRowData(data);
});
const getSelectedRows = () => {
const selectedNodes = gridOptions.api.getSelectedNodes()
const selectedData = selectedNodes.map( node => node.data )
const selectedDataStringPresentation = selectedData.map( node => `${node.make} ${node.model}` ).join(', ')
alert('Selected nodes: ' + selectedDataStringPresentation);
}
</script>
</body>
</html>
Summary
With this Javascript datagrid tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid and how how to use its api object to call methods.
Next Steps
The best thing you can check after the Javascript grid tutorial is the features overview. It provides an extensive review of what you can achieve with AG Grid. In addition, you can go through the following help articles to learn more about the features we enabled:
- Get Started with AG Grid
- Getting Started
- The Project Setup
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Summary
- Next Steps
- Getting Started
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Customise the Theme Look
- AG Grid & Angular Compatibility Chart
- Summary
- Getting Started
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping (enterprise)
- Customise the Theme Look
- AG Grid & React Compatibility Chart
- Summary
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Customise the Theme Look
- Summary

AG Studio Launch Week 🚀🚀🚀 28 Sep - 2 Oct 2026 🚀🚀🚀 Join now




Core Features

Advanced Features

Vue Data GridQuick Start

Version 36.1.0

AG Grid is a high-performance Vue Data Grid library for building Vue Tables with unbeatable performance and hundreds of features. Available in Community and Enterprise editions. Visit Community vs. Enterprise to learn more.

Create a Vue Data Grid Copy Link

Add AG Grid to your application in 60 seconds:

1

NPM Install Copy Link

Install the ag-grid-vue3 package, which also installs ag-grid-community:

npm install ag-grid-vue3
2

Register Modules Copy Link

Register the AllCommunityModule to access all Community features:

import { AllCommunityModule, ModuleRegistry } from 'ag-grid-community';

// Register all Community features
ModuleRegistry.registerModules([AllCommunityModule]);

To minimize bundle size, only register the modules you want to use. See the Modules page for more information.

3

Import the Vue Data Grid Copy Link

<script>
import { AgGridVue } from "ag-grid-vue3"; // Vue Data Grid Component

export default {
    name: "App",
    components: {
        AgGridVue, // Add Vue Data Grid component
    },
    setup() {},
};
</script>
4

Define Rows and Columns Copy Link

setup() {
    // Row Data: The data to be displayed.
    const rowData = ref([
        { make: "Tesla", model: "Model Y", price: 64950, electric: true },
        { make: "Ford", model: "F-Series", price: 33850, electric: false },
        { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    ]);

    // Column Definitions: Defines the columns to be displayed.
    const colDefs = ref([
        { field: "make" },
        { field: "model" },
        { field: "price" },
        { field: "electric" }
    ]);

    return {
        rowData,
        colDefs,
    };
},
5

Vue Data Grid Component Copy Link

Set Rows and Columns as ag-grid-vue component attributes. Styling is applied through the class and style attributes.

<template>
    <!-- The AG Grid component -->
    <ag-grid-vue
        :rowData="rowData"
        :columnDefs="colDefs"
        style="height: 500px"
    >
    </ag-grid-vue>
</template>
6

Example Vue Data Grid Copy Link

Below is a live example of the application running. Click </> Code to see the code.

To live-edit the code, open the example in CodeSandbox or Plunker using the buttons to the lower-right.

Next Steps Copy Link

Now that you have a basic Vue Data Grid running, choose one of the following options to continue your learning journey:

Angular Grid: Get Started with AG Grid
AG Grid is the industry standard for Angular Enterprise Applications. Developers using AG Grid are building applications that would not be possible if AG Grid did not exist.
import { Component } from '@angular/core';
@Component({
selector: 'my-app',
templateUrl: './app.component.html',
styleUrls: [ './app.component.scss' ]
})
export class AppComponent {
columnDefs = [
{ field: 'make' },
{ field: 'model' },
{ field: 'price' }
];
rowData = [
{ make: 'Toyota', model: 'Celica', price: 35000 },
{ make: 'Ford', model: 'Mondeo', price: 32000 },
{ make: 'Porsche', model: 'Boxter', price: 72000 }
];
}
<ag-grid-angular
style="width: 500px; height: 150px;"
class="ag-theme-alpine"
[rowData]="rowData"
[columnDefs]="columnDefs">
</ag-grid-angular>
Please refer to our Compatibility Chart for Supported Versions of Angular & AG Grid.
Getting Started
Below we walk through the necessary steps to add AG Grid (both Community and Enterprise are covered) to an Angular project and configure some grid features. In particular, we will go through the following steps:
- Add AG Grid to Your Project
- Enable Sorting and Filtering
- Fetch Remote Data
- Enable Selection
- Grouping (Enterprise)
- Customise the Theme Look
- Summary

Add AG Grid to Your Project
For the purposes of this tutorial, we are going to scaffold an Angular app with angular CLI. Don't worry if your project has a different configuration. AG Grid and its Angular wrapper are distributed as NPM packages, which should work with any common Angular project module bundler setup. Let's follow the Angular CLI instructions - run the following in your terminal:
npm install -g @angular/cli
ng new my-app --style scss --routing false
cd my-app
ng serve
We are passing --style scss
to the app scaffolding command so that we may customise the
grid theme look through Sass variables.
If everything goes well, ng serve
has started the web server. You can open your app at
localhost:4200.
As a next step, let's add the AG Grid NPM packages. run the following command in my-app
(you may need a new instance of | the terminal):
npm install --save ag-grid-community ag-grid-angular
npm install # in certain circumstances npm will perform an "auto prune". This step ensures all expected dependencies are | present
After a few seconds of waiting, you should be good to go. Let's get to the actual coding! As a first
step, let's add the AG Grid Angular module to our app module (src/app/app.module.ts
):
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppComponent } from './app.component';
import { AgGridModule } from 'ag-grid-angular';
@NgModule({
declarations: [AppComponent],
imports: [
BrowserModule,
AgGridModule.withComponents([])
],
providers: [],
bootstrap: [AppComponent]
})
export class AppModule {}
The withComponents
call is necessary for the grid to be able to use Angular
components as cells / headers - you can ignore it for now.
The next step is to add the AG Grid styles - replace the content of
src/styles.scss
with the following code:
@import "../node_modules/ag-grid-community/dist/styles/ag-grid.css";
@import "../node_modules/ag-grid-community/dist/styles/ag-theme-alpine.css";
The code above imports the grid "structure" stylesheet (ag-grid.css
), and one of the
available grid themes: (ag-theme-alpine.css
). The grid ships several different themes; pick one
that matches your project design. You can customise it further with Sass variables, a technique
which we will cover further down the road.
Next, let's declare the basic grid configuration. Edit src/app.component.ts
:
import { Component } from '@angular/core';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.scss']
})
export class AppComponent {
columnDefs = [
{ field: 'make' },
{ field: 'model' },
{ field: 'price'}
];
rowData = [
{ make: 'Toyota', model: 'Celica', price: 35000 },
{ make: 'Ford', model: 'Mondeo', price: 32000 },
{ make: 'Porsche', model: 'Boxter', price: 72000 }
];
}
The code above presents two essential configuration properties of the grid -
the column definitions
(columnDefs
) and the data (rowData
). In our case, the column definitions contain three columns;
each column entry specifies the header label and the data field to be displayed in the body of the table.
Finally, let's add the component definition to our template. Edit app/app.component.html
and remove the scaffold code:
<ag-grid-angular
style="width: 500px; height: 500px;"
class="ag-theme-alpine"
[rowData]="rowData"
[columnDefs]="columnDefs"
>
</ag-grid-angular>
This is the ag-grid component definition, with two property bindings - rowData
and columnDefs
.
The component also accepts the standard DOM style
and class
. We have set the class to ag-theme-alpine
,
which defines the grid theme. As you may have already noticed, the CSS class matches the name of CSS
file we imported earlier.
If everything works as expected, you should see a simple grid like the one on the screenshot:

Enable Sorting And Filtering
So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the
least/most expensive? Well, enabling sorting in AG Grid is actually quite simple - all you
need to do is set the sortable
property to each column you want to be able to sort by.
columnDefs = [
{ field: 'make', sortable: true },
{ field: 'model', sortable: true },
{ field: 'price', sortable: true }
];
After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.
Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) of rows, with many columns. In a data set like this filtering is your friend.
As with sorting, enabling filtering is as easy as setting the filter
property:
columnDefs = [
{ field: 'make', sortable: true, filter: true },
{ field: 'model', sortable: true, filter: true },
{ field: 'price', sortable: true, filter: true }
];
With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with a filtering UI which lets you choose the kind of filter and the text that you want to filter by.

Fetch Remote Data
Displaying hard-coded data in JavaScript is not going to get us very far. In the real world,
most of the time, we are dealing with data that resides on a remote server. Thanks to Angular,
implementing this is actually quite simple. Notice that the actual data fetching is performed
outside of the grid component - We are using Angular's HttpClient
and an async pipe. As a first step, let's add the HttpModule
to our app module:
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppComponent } from './app.component';
import { AgGridModule } from 'ag-grid-angular';
import { HttpClientModule } from '@angular/common/http';
@NgModule({
declarations: [AppComponent],
imports: [
BrowserModule,
HttpClientModule,
AgGridModule.withComponents([])
],
providers: [],
bootstrap: [AppComponent]
})
export class AppModule {}
Now, let's remove the hard-coded data and fetch it from a remote server.
Edit the src/app.component.ts
to this:
import { Component, OnInit } from '@angular/core';
import { HttpClient } from '@angular/common/http';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {
columnDefs = [
{ field: 'make', sortable: true, filter: true },
{ field: 'model', sortable: true, filter: true },
{ field: 'price', sortable: true, filter: true }
];
rowData: any[];
constructor(private http: HttpClient) {
}
ngOnInit() {
this.rowData = this.http.get('https://www.ag-grid.com/example-assets/small-row-data.json');
}
}
The above code turns the rowData
from a hard-coded array to an Observable
. For the grid to work with
it, we need to add an async pipe to the property:
<ag-grid-angular
style="width: 500px; height: 500px;"
class="ag-theme-alpine"
[rowData]="rowData | async"
[columnDefs]="columnDefs"
>
</ag-grid-angular>
The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid. However, you will see an additional HTTP request performed if you open your developer tools.
Enable Selection
Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.
Fortunately, the above task is quite simple with AG Grid. As you may have already guessed, it is just a
matter of adding and changing couple of properties. Edit src/app.component.ts
first:
import { Component, OnInit, ViewChild } from '@angular/core';
import { HttpClient } from '@angular/common/http';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {
columnDefs = [
{ field: 'make', sortable: true, filter: true, checkboxSelection: true },
{ field: 'model', sortable: true, filter: true },
{ field: 'price', sortable: true, filter: true }
];
rowData: any[];
constructor(private http: HttpClient) {
}
ngOnInit() {
this.rowData = this.http.get('https://www.ag-grid.com/example-assets/small-row-data.json');
}
}
Next, let's enable multiple row selection, so that the user can pick many rows:
<ag-grid-angular
style="width: 500px; height: 500px;"
class="ag-theme-alpine"
[rowData]="rowData | async"
[columnDefs]="columnDefs"
rowSelection="multiple"
>
</ag-grid-angular>
We took a bit of a shortcut here, by not binding the property value. Without []
, the
assignment will pass the attribute value as a string, which is fine for our purposes.
Great! Now the first column contains a checkbox that, when clicked, selects the row. The only
thing we have to add is a button that gets the selected data and sends it to the server. To do this,
we are going to use the AG Grid API - we will access
it through the component instance. To access to component instance we will need to add the
#agGrid
id to our component.
<button (click)="getSelectedRows()">Get Selected Rows</button>
<ag-grid-angular
#agGrid
style="width: 500px; height: 500px;"
class="ag-theme-alpine"
[rowData]="rowData | async"
[columnDefs]="columnDefs"
rowSelection="multiple"
>
</ag-grid-angular>
Now let's make the instance accessible in our component:
import { Component, OnInit, ViewChild } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { AgGridAngular } from 'ag-grid-angular';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {
@ViewChild('agGrid') agGrid: AgGridAngular;
columnDefs = [
{ field: 'make', sortable: true, filter: true, checkboxSelection: true },
{ field: 'model', sortable: true, filter: true },
{ field: 'price', sortable: true, filter: true }
];
rowData: any[];
constructor(private http: HttpClient) {
}
ngOnInit() {
this.rowData = this.http.get('https://www.ag-grid.com/example-assets/small-row-data.json');
}
}
The only thing we have to add is the getSelectedRows
method to the component.
import { Component, OnInit, ViewChild } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { AgGridAngular } from 'ag-grid-angular';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {
@ViewChild('agGrid') agGrid: AgGridAngular;
columnDefs = [
{ field: 'make', sortable: true, filter: true, checkboxSelection: true },
{ field: 'model', sortable: true, filter: true },
{ field: 'price', sortable: true, filter: true }
];
rowData: any[];
constructor(private http: HttpClient) {
}
ngOnInit() {
this.rowData = this.http.get('https://www.ag-grid.com/example-assets/small-row-data.json');
}
getSelectedRows() {
const selectedNodes = this.agGrid.api.getSelectedNodes();
const selectedData = selectedNodes.map(node => node.data );
const selectedDataStringPresentation = selectedData.map(node => `${node.make} ${node.model}`).join(', ');
alert(`Selected nodes: ${selectedDataStringPresentation}`);
}
}
Well, we cheated a bit. Calling alert
is not exactly a call to our backend.
Hopefully you will forgive us this shortcut for the sake of keeping the article short and
simple. Of course, you can substitute that bit with a real-world application logic after you
are done with the tutorial.
Grouping
Grouping is a feature exclusive to AG Grid Enterprise. You are free to trial AG Grid Enterprise to see what you think. You only need to get in touch if you want to start using AG Grid Enterprise in a project intended for production.
In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data.
Our current data set is pretty small so let's switch to a larger one:
ngOnInit() {
- this.rowData = this.http.get('https://www.ag-grid.com/example-assets/small-row-data.json');
+ this.rowData = this.http.get('https://www.ag-grid.com/example-assets/row-data.json');
}
Let's enable the enterprise features of ag-grid. Install the additional package:
npm install --save ag-grid-enterprise
Then, add the import to app.module.ts
:
import { AgGridModule } from 'ag-grid-angular';
import { HttpClientModule } from '@angular/common/http';
+ import 'ag-grid-enterprise';
If everything is ok, you should see a message in the console that tells you there is no enterprise license key. You can ignore the message as we are trialing. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

Now, let's enable grouping! Add an autoGroupColumnDef
property and change the
columnDefs
to the following:
export class AppComponent implements OnInit {
@ViewChild('agGrid') agGrid: AgGridAngular;
defaultColDef = {
sortable: true,
filter: true
};
columnDefs = [
{ field: 'make', rowGroup: true },
{ field: 'price' }
];
autoGroupColumnDef = {
headerName: 'Model',
field: 'model',
cellRenderer: 'agGroupCellRenderer',
cellRendererParams: {
checkbox: true
}
};
rowData: any[];
constructor(private http: HttpClient) {
}
ngOnInit() {
this.rowData = this.http.get('https://www.ag-grid.com/example-assets/row-data.json');
}
getSelectedRows() {
const selectedNodes = this.agGrid.api.getSelectedNodes();
const selectedData = selectedNodes.map(node => {
if (node.groupData) {
return { make: node.key, model: 'Group' };
}
return node.data;
});
const selectedDataStringPresentation = selectedData.map(node => `${node.make} ${node.model}`).join(', ');
alert(`Selected nodes: ${selectedDataStringPresentation}`);
}
}
Add the the autoGroupColumnDef
and defaultColDef
properties to the template too:
class="ag-theme-alpine"
+ [defaultColDef]="defaultColDef"
+ [autoGroupColumnDef]="autoGroupColumnDef"
There we go! The grid now groups the data by make
, while listing the model
field value when expanded.
Notice that grouping works with checkboxes as well - the groupSelectsChildren
property adds a
group-level checkbox that selects/deselects all items in the group.
Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.
Customise the Theme Look
The last thing which we are going to do is to change the grid look and feel by modifying some of the theme's parameters.
Open style.scss
and add some parameters:
@import "../node_modules/ag-grid-community/src/styles/ag-grid.scss";
@import "../node_modules/ag-grid-community/src/styles/ag-theme-alpine/sass/ag-theme-alpine-mixin.scss";
.ag-theme-alpine {
@include ag-theme-alpine((
odd-row-background-color: #CFD8DC
));
}
You can find a full list of theme parameters here.
If everything is configured correctly, the second row of the grid will get slightly darker. Congratulations! You now know now bend the grid look to your will - there are a few dozens more Sass variables that let you control the font family and size, border color, header background color and even the amount of spacing in the cells and columns. The full theme parameter list is available in the themes documentation section.
AG Grid & Angular Compatibility Chart
Due to a breaking change in Angular 10 you may experience the following error when building:
Generic type 'ModuleWithProviders<T>' requires 1 type argument(s)
If you wish to use Angular 10 with AG Grid versions 18-23 then you need to set "skipLibCheck": true
in tsconfig.app.json
Please note however that this is a workaround and Angular 10 is only
officially supported with AG Grid 24+.
Angular Version | AG Grid Versions |
---|---|
6 | 18 - 22 |
7 - 9 | 18 - 23+ (23 recommended for Angular 9) |
7 - 10+ | 24+ (24+ for Angular 10) |
Summary
With this Angular grid tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid, how to access its API object, and how to change the styling of the component.
Want to know more?
Want to see some full examples of customising AG Grid using Angular components? See this blog written by Max Koretskyi (aka Angular in Depth Wizard) Learn to customise Angular grid in less than 10 minutes.
A full working examples of AG Grid and Angular can be found in Github, illustrating (amongst others) rich grids, filtering with angular components and master/detail.
- Get Started with AG Grid
- Getting Started
- The Project Setup
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Summary
- Next Steps
- Getting Started
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Customise the Theme Look
- AG Grid & Angular Compatibility Chart
- Summary
- Getting Started
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping (enterprise)
- Customise the Theme Look
- AG Grid & React Compatibility Chart
- Summary
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Customise the Theme Look
- Summary

React Grid: Get Started with AG Grid
AG Grid is the industry standard for React Enterprise Applications. Developers using AG Grid are building applications that would not be possible if AG Grid did not exist.
import React, { useState } from 'react';
import { render } from 'react-dom';
import { AgGridColumn, AgGridReact } from 'ag-grid-react';
import 'ag-grid-enterprise';
import 'ag-grid-community/dist/styles/ag-grid.css';
import 'ag-grid-community/dist/styles/ag-theme-alpine.css';
const App = () => {
const [gridApi, setGridApi] = useState(null);
const [gridColumnApi, setGridColumnApi] = useState(null);
const [rowData, setRowData] = useState([
{ make: "Toyota", model: "Celica", price: 35000 },
{ make: "Ford", model: "Mondeo", price: 32000 },
{ make: "Porsche", model: "Boxter", price: 72000 }
]);
const onGridReady = params => {
setGridApi(params.api);
setGridColumnApi(params.columnApi);
}
return (
<div className="ag-theme-alpine" style={{ height: 400, width: 600 }}>
<AgGridReact
onGridReady={onGridReady}
rowData={rowData}>
<AgGridColumn field="make"></AgGridColumn>
<AgGridColumn field="model"></AgGridColumn>
<AgGridColumn field="price"></AgGridColumn>
</AgGridReact>
</div>
);
};
render(<App />, document.getElementById('root'));
<div id="root"></div>
Please refer to our Compatibility Chart for Supported Versions of React & AG Grid.
Getting Started
In this article, we will walk you through the necessary steps to add AG Grid (both Community and Enterprise are covered) to an existing React project, and configure some of the essential features of it. We will show you some of the fundamentals of the grid (passing properties, using the API, etc). As a bonus, we will also tweak the grid's visual appearance using Sass variables.

Add AG Grid to Your Project
For the purposes of this tutorial, we are going to scaffold a react app with create-react-app. Don't worry if your project has a different configuration. AG Grid and the React wrapper are distributed as NPM packages, which should work with any common React project module bundler setup. Let's follow the create-react-app instructions - run the following commands in your terminal:
npx create-react-app my-app
cd my-app
npm start
npx comes with npm 5.2+ and higher, see instructions for older npm versions
If everything goes well, npm start
has started the web server and conveniently opened a browser
pointing to localhost:3000.
As a next step, let's add the AG Grid NPM packages. Run the following command in my-app
(you may need a new instance of the terminal):
npm install --save ag-grid-community ag-grid-react
After a few seconds of waiting, you should be good to go. Let's get to the actual coding! Open src/App.js
in your
favorite text editor and change its contents to the following:
import React, { useState } from 'react';
import { AgGridColumn, AgGridReact } from 'ag-grid-react';
import 'ag-grid-community/dist/styles/ag-grid.css';
import 'ag-grid-community/dist/styles/ag-theme-alpine.css';
const App = () => {
const [gridApi, setGridApi] = useState(null);
const [gridColumnApi, setGridColumnApi] = useState(null);
const [rowData, setRowData] = useState([
{ make: "Toyota", model: "Celica", price: 35000 },
{ make: "Ford", model: "Mondeo", price: 32000 },
{ make: "Porsche", model: "Boxter", price: 72000 }
]);
return (
<div className="ag-theme-alpine" style={{ height: 400, width: 600 }}>
<AgGridReact
rowData={rowData}>
<AgGridColumn field="make"></AgGridColumn>
<AgGridColumn field="model"></AgGridColumn>
<AgGridColumn field="price"></AgGridColumn>
</AgGridReact>
</div>
);
};
export default App;

Let's go over the App.jsx
changes we made:
import { AgGridColumn, AgGridReact } from 'ag-grid-react';
import 'ag-grid-community/dist/styles/ag-grid.css';
import 'ag-grid-community/dist/styles/ag-theme-alpine.css';
The three lines above import the AgGridReact
and AgGridColumn
components, the grid
"structure" stylesheet (ag-grid.css
), and one of the available grid themes: (ag-theme-alpine.css
).
The grid ships several different themes; pick one that matches your project design. You can customise it further with Sass variables, a technique which we will cover further down the road.
const [rowData, setRowData] = useState([
{make: "Toyota", model: "Celica", price: 35000},
{make: "Ford", model: "Mondeo", price: 32000},
{make: "Porsche", model: "Boxter", price: 72000}
]);
//...
<AgGridReact
rowData={rowData}>
<AgGridColumn field="make"></AgGridColumn>
<AgGridColumn field="model"></AgGridColumn>
<AgGridColumn field="price"></AgGridColumn>
</AgGridReact>
The code above presents two essential configuration properties of the grid -
the column definitions
(AgGridColumn
) and the data (rowData
). In our case, the column definitions contain three columns;
each column entry specifies the header label and the data field to be displayed in the body of the table.
The actual data is defined in the rowData
as an array of objects. Notice that the fields of the
objects match the field
values in the AgGridColumn
configuration objects.
<div className="ag-theme-alpine" style={{ height: 400, width: 600 }}>
<AgGridReact
rowData={rowData}>
<AgGridColumn field="make"></AgGridColumn>
<AgGridColumn field="model"></AgGridColumn>
<AgGridColumn field="price"></AgGridColumn>
</AgGridReact>
</div>
Finally, the JSX code above describes a wrapper DIV
element which sets the grid dimensions and
specifies the grid's theme by setting the className
to ag-theme-alpine
. As you may have already
noticed, the CSS class matches the name of CSS file we imported earlier.
Enable Sorting And Filtering
So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the
least/most expensive? Well, enabling sorting in AG Grid is actually quite simple - all you need to
do is set the sort
property on the column definitions.
<AgGridColumn field="make" sortable={ true }></AgGridColumn>
<AgGridColumn field="model" sortable={ true }></AgGridColumn>
<AgGridColumn field="price" sortable={ true }></AgGridColumn>
After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.
Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) of rows, with many columns. In a data set like this filtering is your friend.
As with sorting, enabling filtering is as easy as setting the filter
property:
<AgGridColumn field="make" sortable={ true } filter={ true }></AgGridColumn>
<AgGridColumn field="model" sortable={ true } filter={ true }></AgGridColumn>
<AgGridColumn field="price" sortable={ true } filter={ true }></AgGridColumn>
With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with a filtering UI which lets you choose the kind of filter and the text that you want to filter by.

Fetch Remote Data
Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most
of the time, we are dealing with data that resides on a remote server. Thanks to React, implementing
this is actually quite simple. Notice that the actual data fetching is performed outside of the
grid component - We are using the HTML5 fetch
API.
- const [rowData, setRowData] = useState([
- { make: "Toyota", model: "Celica", price: 35000 },
- { make: "Ford", model: "Mondeo", price: 32000 },
- { make: "Porsche", model: "Boxter", price: 72000 }
- ]);
+ const [rowData, setRowData] = useState([]);
+ useEffect(() => {
+ fetch('https://www.ag-grid.com/example-assets/row-data.json')
+ .then(result => result.json())
+ .then(rowData => setRowData(rowData))
+ }, []);
+
Here, we replaced the rowData
assignment in the constructor with a data fetch from a remote service.
The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid.
Enable Selection
Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.
Fortunately, the above task is quite simple with AG Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties:
- <AgGridColumn field="make" sortable={ true } filter={ true }></AgGridColumn>
+ <AgGridColumn field="make" sortable={ true } filter={true } checkboxSelection={ true }></AgGridColumn>
<AgGridReact
+ rowSelection="multiple"
Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we need the following change:
<div className="ag-theme-alpine" style={{ height: 400, width: 600 }}>
<button onClick={onButtonClick}>Get selected rows</button>
<AgGridReact
rowData={ rowData }
rowSelection="multiple">
<AgGridColumn field="make" sortable={ true } filter={ true } checkboxSelection={ true }></AgGridColumn>
<AgGridColumn field="model" sortable={ true } filter={ true }></AgGridColumn>
<AgGridColumn field="price" sortable={ true } filter={ true }></AgGridColumn>
</AgGridReact>
</div>
Afterwards, add the following event handler at the end of the component class:
const onButtonClick = e => {
const selectedNodes = gridApi.getSelectedNodes()
const selectedData = selectedNodes.map( node => node.data )
const selectedDataStringPresentation = selectedData.map( node => `${node.make} ${node.model}`).join(', ')
alert(`Selected nodes: ${selectedDataStringPresentation}`)
}
Well, we cheated a bit. Calling alert
is not exactly a call to our backend. Hopefully you will forgive
us this shortcut for the sake of keeping the article short and simple. Of course, you can substitute
that bit with a real-world application logic after you are done with the tutorial.
What happened above? Several things:
onGridReady={ params => setGridApi(params.api) }
obtained a reference to the ag-grid API instance;- We added a button with an event handler;
- Inside the event handler, we accessed the grid api object reference to access the currently selected grid row nodes;
- Afterwards, we extracted the row nodes' underlying data items and converted them to a string suitable to be presented to the user in an alert box.
Grouping (enterprise)
Grouping is a feature exclusive to AG Grid Enterprise. You are free to trial AG Grid Enterprise to see what you think. You only need to get in touch if you want to start using AG Grid Enterprise in a project intended for production.
In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data.
Our current data set is pretty small so let's switch to a larger one:
- fetch('https://www.ag-grid.com/example-assets/small-row-data.json')
+ fetch('https://www.ag-grid.com/example-assets/row-data.json')
Let's enable the enterprise features of ag-grid. Install the additional package:
npm install --save ag-grid-enterprise
Then, add the import to your file:
import { AgGridColumn, AgGridReact } from 'ag-grid-react';
+ import 'ag-grid-enterprise';
import 'ag-grid-community/dist/styles/ag-grid.css';
import 'ag-grid-community/dist/styles/ag-theme-alpine.css';
If everything is ok, you should see a message in the console that tells you there is no enterprise license key. You can ignore the message as we are trialing. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

Now, let's enable grouping! Update the AgGridReact
configuration to this:
<div className="ag-theme-alpine" style={{ height: 400, width: 600 }}>
<button onClick={onButtonClick}>Get selected rows</button>
<AgGridReact
onGridReady={onGridReady}
rowData={rowData}
rowSelection="multiple"
+ groupSelectsChildren={true}
+ autoGroupColumnDef=<span>{</span>{
+ headerName: "Model",
+ field: "model",
+ cellRenderer:'agGroupCellRenderer',
+ cellRendererParams: {
+ checkbox: true
+ }
+ }}
- <AgGridColumn field="make" sortable={ true } filter={ true } checkboxSelection={ true }></AgGridColumn>
+ <AgGridColumn field="make" sortable={ true } filter={ true } checkboxSelection={ true } rowGroup={ true }></AgGridColumn>
Here we've updated the component definition and set the autoGroupColumnDef
and
groupSelectsChildren
properties.
There we go! The grid now groups the data by make
, while listing the model
field value when expanded.
Notice that grouping works with checkboxes as well - the groupSelectsChildren
property adds a group-level
checkbox that selects/deselects all items in the group.
Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.
Customise the Theme Look
The last thing which we are going to do is to change the grid look and feel by customising a theme.
By default, AG Grid ships a set of pre-built theme stylesheets. If we want to tweak the colors and the fonts of theme, we should add a Sass preprocessor to our project, override the theme variable values, and refer the ag-grid Sass files instead of the pre-built stylesheets so that the variable overrides are applied.
Adding Sass Preprocessor to create-react-app is well documented - follow the steps outlined in the respective help section.
After you are done with the setup, assuming that you have renamed src/App.css
to src/App.scss
, you can
replace its contents with this:
@import "../node_modules/ag-grid-community/src/styles/ag-grid.scss";
@import "../node_modules/ag-grid-community/src/styles/ag-theme-alpine/sass/ag-theme-alpine-mixin.scss";
.ag-theme-alpine {
@include ag-theme-alpine((
odd-row-background-color: #BFC8DC
));
}
To avoid importing the stylesheets twice, remove the imports from src/App.js
:
import { AgGridColumn, AgGridReact } from 'ag-grid-react';
- import 'ag-grid-community/dist/styles/ag-grid.css';
- import 'ag-grid-community/dist/styles/ag-theme-alpine.css';
If everything is configured correctly, the second row of the grid will be blue. Congratulations! You now know now bend the grid look to your will - there are a few dozens more theme parameters variables that let you control the font family and size, border color, header background color and even the amount of spacing in the cells and columns. The full list of theme parameters is available in the themes documentation section.
AG Grid & React Compatibility Chart
React Version | AG Grid Versions |
---|---|
15.x | 18 - 21.2.0 |
16.3+ | 22+ |
Summary
With this tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid, how to access its API object, and how to change the styling of the component.
- Get Started with AG Grid
- Getting Started
- The Project Setup
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Summary
- Next Steps
- Getting Started
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Customise the Theme Look
- AG Grid & Angular Compatibility Chart
- Summary
- Getting Started
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping (enterprise)
- Customise the Theme Look
- AG Grid & React Compatibility Chart
- Summary
- Add AG Grid to Your Project
- Enable Sorting And Filtering
- Fetch Remote Data
- Enable Selection
- Grouping
- Customise the Theme Look
- Summary